//main.c
#include "gpl951_body.h"
#include "system\system.h"
#include "SPIFlashDriver\SPIFlashDriver.h"
#include "SPIDriver\SPI0_Driver.h"
#include "SPIDriver\SPI1_Driver.h"


void F_BufferInitial(int);
void SPIFlashTest(void);
void SPI0DriverTest_Master(void);
void SPI0DriverTest_Slave(void);
void SPI1DriverTest_Master(void);
void SPI1DriverTest_Slave(void);
void F_SPIFlash_EraseTest(void);
void delay(int);

int TXBuffer[0x1000];
int RXBuffer[0x1000];
unsigned char ID[3];

int testvalue;
long SPIFlash_Addr;
int R_DataLength;

int main()
{
	*P_Clock_Ctrl=(C_PLL_Fast_En+C_SYSCLK_SRC_Div1);	//set system clock as 96MHz
	
	F_SYS_Initial();

	//before enable SPI Flash initial or SPI 0/1 driver, user need selection SPI IF pin first.
//	*P_IOF_Mux=(C_IOF_SPI0_En+C_IOF_SPICS_GPIO);		//set SPI0 enable on PortF
	*P_IOF_Mux=(C_IOF_SPI1_En+C_IOF_SPICS_GPIO);		//set SPI1 enable on PortF
		

//=====================================================	
//	SPIFlashTest();		//SPI Flash FIFO Test
//----------------------------
//	SPI0DriverTest_Master();	//for master device function code
//	SPI0DriverTest_Slave();		//for slave device function code

//	SPI1DriverTest_Master();	//for master device function code
	SPI1DriverTest_Slave();		//for slave device function code


	while(1)
		*P_WatchDog_Clear = C_WDT_Clear;		
}		

//=========SPI interface driver master/slave verify ==================================================
//=========master mode first, then slave mode receive back to check=====
void SPI0DriverTest_Master(void)
{
	unsigned char ret;
	unsigned int i;

	SPI0_Intial(7);		//set SPI clock as system clock/32. 

	*P_IOA_Dir&=~0x01;		//set IOA0 as input pull low
	*P_IOA_Attrib&=~0x01;
	*P_IOA_Buffer&=~0x01;
	delay(10);

	while(!(*P_IOA_Data & 0x01))		//wait IOA0 as high, here, is wait slave device ready.
		*P_WatchDog_Clear = C_WDT_Clear;		
	i=0;
	TXBuffer[i]=0x0052;		
	for( i=1; i<0x800; i++)
		TXBuffer[i]=i+0x1266;	
	
	R_DataLength=0x0d;	
	i=0;	
	SPI0_CSLow();	
	SPI0_WriteOneByte(TXBuffer[i++]);
	SPI0_CSHigh();
	delay(1000);	//wait for slave
	
	SPI0_CSLow();	
	SPI0_WriteNByte(TXBuffer+i, R_DataLength);
	SPI0_CSHigh();

	delay(1000);	//wait for slave

//----- slave mode receive data-----
	for(i=0; i<0x800; i++)		//clear RX buffer
		RXBuffer[i]=00;	

	Slave_SPI0_Intial();
	Slave_SPI0_WriteOneByte(0x00);	//if read ok, data will be put in Slave_SPI0_ReadOneByteData.
	*P_IOA_Dir|=0x01;		//set IOA0 as output high, to notice master 
	*P_IOA_Attrib|=0x01;
	*P_IOA_Buffer|=0x01;

	do
	{	
		ret=Slave_SPI0_Status();				
		if(ret==0xFFFF)							 
		{	while(1)
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;	
	}while(ret);
	
	i=0;	
	RXBuffer[i++]=Slave_SPI0_ReadOneByteData;	
	
	Slave_SPI0_ReadNByte(RXBuffer+i, R_DataLength);		//read N byte test
	do
	{	
		ret=Slave_SPI0_Status();					//SPI FIFO buffer is 8bytes. So, we suggest master call a delay after each 8 bytes data sent. 
		if(ret==0xFFFF)								//This delay is wait for slave process received data. 
		{	while(1)
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;
	}while(ret);
	
	for(i=0; i<(R_DataLength/2); i++)
	{	
	  if(RXBuffer[i]!=TXBuffer[i])
	  {
	  	 while(1)
	  	 *P_WatchDog_Clear = C_WDT_Clear;	
	  }		
	}
}

//============================================================
//===== slave mode first, then master mode send back===========
void SPI0DriverTest_Slave(void)
{
	unsigned char ret;
	unsigned int i;	

	for(i=0; i<0x800; i++)		//clear RX buffer
	RXBuffer[i]=00;	

	R_DataLength=0x0d;
	Slave_SPI0_Intial();
	Slave_SPI0_WriteOneByte(0x00);	//if read ok, data will be put in Slave_SPI0_ReadOneByteData.
	
	*P_IOA_Dir|=0x01;		//set IOA0 as output high, to notice master 
	*P_IOA_Attrib|=0x01;
	*P_IOA_Buffer|=0x01;

	do
	{	
		ret=Slave_SPI0_Status();		
		if(ret==0xFFFF)						
		{	
			while(1);
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;
	}while(ret);
	
	i=0;	
	RXBuffer[i++]=Slave_SPI0_ReadOneByteData;	
	
	Slave_SPI0_ReadNByte(RXBuffer+i, R_DataLength);		//read N byte test
	do
	{	
		ret=Slave_SPI0_Status();				//SPI FIFO buffer is 8bytes. So, we suggest master call a delay after each 8 bytes data sent.   
		if(ret==0xFFFF)							//This delay is wait for slave process received data. 
		{	while(1)
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;
	}while(ret);
	
	i=0;
	TXBuffer[i]=0x0052;		
	for( i=1; i<0x800; i++)
		TXBuffer[i]=i+0x1266;	
	
	for(i=0; i<(R_DataLength/2); i++)
	{	
	  if(RXBuffer[i]!=TXBuffer[i])
	  {
	  	 while(1)
	  	 *P_WatchDog_Clear = C_WDT_Clear;	
	  }		
	}
//--------  master mode TX------------------
	*P_IOA_Dir&=~0x01;		//set IOA0 as input pull low
	*P_IOA_Attrib&=~0x01;
	*P_IOA_Buffer&=~0x01;
	delay(10);

	while(!(*P_IOA_Data & 0x01))		//wait IOA0 as high, here, is wait slave device ready.
		*P_WatchDog_Clear = C_WDT_Clear;		

	SPI0_Intial(7);		//set SPI clock as system clock/32. 
	i=0;	
	SPI0_CSLow();	
	SPI0_WriteOneByte(RXBuffer[i++]);
	SPI0_CSHigh();
	delay(1000);	//wait for slave
	
	SPI0_CSLow();	
	SPI0_WriteNByte(RXBuffer+i, R_DataLength);
	SPI0_CSHigh();

	delay(1000);	//wait for slave
//---------------------------------------	
}

//=========SPI interface driver master/slave verify ==================================================
//=========master mode first, then slave mode receive back to check=====
void SPI1DriverTest_Master(void)
{
	unsigned char ret;
	unsigned int i;

	SPI1_Intial(7);		//set SPI clock as system clock/32. 

	*P_IOA_Dir&=~0x01;		//set IOA0 as input pull low
	*P_IOA_Attrib&=~0x01;
	*P_IOA_Buffer&=~0x01;
	delay(10);

	while(!(*P_IOA_Data & 0x01))		//wait IOA0 as high, here, is wait slave device ready.
		*P_WatchDog_Clear = C_WDT_Clear;		
	i=0;
	TXBuffer[i]=0x0052;		
	for( i=1; i<0x800; i++)
		TXBuffer[i]=i+0x1266;	
	
	R_DataLength=0x267;	
	i=0;	
	SPI1_CSLow();	
	SPI1_WriteOneByte(TXBuffer[i++]);
	SPI1_CSHigh();
	delay(1000);	//wait for slave
	
	SPI1_CSLow();	
	SPI1_WriteNByte(TXBuffer+i, R_DataLength);
	SPI1_CSHigh();

	delay(1000);	//wait for slave

//----- slave mode receive data-----
	for(i=0; i<0x800; i++)		//clear RX buffer
		RXBuffer[i]=00;	

	Slave_SPI1_Intial();
	Slave_SPI1_WriteOneByte(0x00);	//if read ok, data will be put in Slave_SPI0_ReadOneByteData.
	*P_IOA_Dir|=0x01;			//set IOA0 as output high, to notice master 
	*P_IOA_Attrib|=0x01;
	*P_IOA_Buffer|=0x01;

	do
	{	
		ret=Slave_SPI1_Status();
		if(ret==0xFFFF)
		{	while(1)
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;	
	}while(ret);
	
	i=0;	
	RXBuffer[i++]=Slave_SPI1_ReadOneByteData;	
	
	Slave_SPI1_ReadNByte(RXBuffer+i, R_DataLength);		//read N byte test
	do
	{	
		ret=Slave_SPI1_Status();
		if(ret==0xFFFF)
		{	while(1)
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;
	}while(ret);
	
	for(i=0; i<(R_DataLength/2); i++)
	{	
	  if(RXBuffer[i]!=TXBuffer[i])
	  {
	  	 while(1)
	  	 *P_WatchDog_Clear = C_WDT_Clear;	
	  }		
	}
}

//============================================================
//===== slave mode first, then master mode send back===========
void SPI1DriverTest_Slave(void)
{
	unsigned char ret;
	unsigned int i;	

	for(i=0; i<0x800; i++)		//clear RX buffer
	RXBuffer[i]=00;	

	R_DataLength=0x267;
	Slave_SPI1_Intial();
	Slave_SPI1_WriteOneByte(0x00);	//if read ok, data will be put in Slave_SPI0_ReadOneByteData.
	
	*P_IOA_Dir|=0x01;		//set IOA0 as output high, to notice master 
	*P_IOA_Attrib|=0x01;
	*P_IOA_Buffer|=0x01;

	do
	{	
		ret=Slave_SPI1_Status();
		if(ret==0xFFFF)
		{	
			while(1);
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;
	}while(ret);
	
	i=0;	
	RXBuffer[i++]=Slave_SPI1_ReadOneByteData;	
	
	Slave_SPI1_ReadNByte(RXBuffer+i, R_DataLength);		//read N byte test
	do
	{	
		ret=Slave_SPI1_Status();
		if(ret==0xFFFF)
		{	while(1)
			*P_WatchDog_Clear = C_WDT_Clear;	
		}
		*P_WatchDog_Clear = C_WDT_Clear;
	}while(ret);
	
	i=0;
	TXBuffer[i]=0x0052;		
	for( i=1; i<0x800; i++)
		TXBuffer[i]=i+0x1266;	
	
	for(i=0; i<(R_DataLength/2); i++)
	{	
	  if(RXBuffer[i]!=TXBuffer[i])
	  {
	  	 while(1)
	  	 *P_WatchDog_Clear = C_WDT_Clear;	
	  }		
	}
//--------  master mode TX------------------
	*P_IOA_Dir&=~0x01;		//set IOA0 as input pull low
	*P_IOA_Attrib&=~0x01;
	*P_IOA_Buffer&=~0x01;
	delay(10);

	while(!(*P_IOA_Data & 0x01))		//wait IOA0 as high, here, is wait slave device ready.
		*P_WatchDog_Clear = C_WDT_Clear;		

	SPI1_Intial(7);		//set SPI clock as system clock/32. 
	i=0;	
	SPI1_CSLow();	
	SPI1_WriteOneByte(RXBuffer[i++]);
	SPI1_CSHigh();
	delay(1000);	//wait for slave
	
	SPI1_CSLow();	
	SPI1_WriteNByte(RXBuffer+i, R_DataLength);
	SPI1_CSHigh();

	delay(1000);	//wait for slave
//---------------------------------------	
}


void delay(int a)
{
    int i;
    for(i=0; i<a; i++)
    {
	*P_WatchDog_Clear = C_WDT_Clear;
	__asm("nop");
    }	
}

void SPIFlashTest(void)
{
	unsigned char ret, statusdata;
	unsigned int i, FlashType;

	SPIFlash_Initial(3);		//Here, SPI_CLK_SEL=0 is system clock/2. SPI_CLK_SEL=1 is system clock/4. ... SPI_CLK_SEL=7 is system clock/128.   

//==========SPI Flash Code Test===================	
	if(SPIFlash_RDID(ID) != 0)
	{
		while(1)
			*P_WatchDog_Clear = C_WDT_Clear;
	}
	
//========= SPI Flash status register =============	
	ret=SPIFlash_RDSR();
	if(ret==-1)
	{	while(1)				//SPI Flash Timeout
		*P_WatchDog_Clear = C_WDT_Clear;
	}	
	statusdata=ret&0x00FF;	
	statusdata=0x80;		//statusdata|=0xbc;
	ret=SPIFlash_WRSR(statusdata);
	if(ret==-1 || ret==-2)
	{	while(1)				//SPI Flash Timeout or busy
		*P_WatchDog_Clear = C_WDT_Clear;
	}	
	
	do
	{
	ret=SPIFlash_RDSR();
	if(ret==-1)
	{	while(1)				//SPI Flash Timeout
		*P_WatchDog_Clear = C_WDT_Clear;
	}	
	} while(ret&0x01);			//write busy check 
	ret&=0x0ff;
	if(ret!=statusdata)		
	{	while(1)				//SPI Flash Timeout
		*P_WatchDog_Clear = C_WDT_Clear;
	}	
	
//=========SPI Flash Erase ======================================		
	SPIFlash_Addr=0x01000000;
	F_SPIFlash_EraseTest();
//=========SPI Flash FIFO Write =================================================		
	testvalue=0x03;
	F_BufferInitial(testvalue);

	SPIFlash_Addr=0x01000200;
	R_DataLength=0x2000;				//8K byte 
	ret=SPIFlash_Write(SPIFlash_Addr, TXBuffer, R_DataLength);
	if(ret== -2)					//busy
		ret = SPIFlash_Write(SPIFlash_Addr, TXBuffer, R_DataLength);	//write again
	if(ret != 0)
		while(1);					//write fail

//=========SPI Flash FIFO Read =================================================	
	ret = SPIFlash_Read(SPIFlash_Addr, RXBuffer, R_DataLength);
	if(ret== -2)					//busy
		ret = SPIFlash_Read(SPIFlash_Addr, RXBuffer, R_DataLength);		//read again
	if(ret != 0)
		while(1);				//SPI Flash Timeout
	
	for(i=0; i< 0x1000; i++)
	{
		if(TXBuffer[i] != RXBuffer[i])
			while(1);
	}
	
	
//-----------------	SPI driver DMA test----------	
	testvalue=0x03;
	F_BufferInitial(testvalue);

	switch(ID[2])
	{
		case 0x19:			//256Mb
		FlashType=0x01;		//4byte addressing
		break;	
		case 0x1a:			//MX 512Mb
        FlashType=0x01;		//4byte addressing
		break;
		case 0x20:			//gigadevice 512Mb
		FlashType=0x01;		//4byte addressing
		break;	
		default:
		FlashType=0x00;		//default 3byte addressing
		break;
	}	


	ret=SPIFlash_RDSR();
	if(ret==-1)
		while(1);
	if(ret & 0x01)
		while(1);		//busy

	SPI1_CSLow();
	if (FlashType)
	{	
	SPI1_WriteOneByte(0x13);	//read command		
	i=SPIFlash_Addr >> 24;		
	SPI1_WriteOneByte(i);		//address(32)
	}
	else
	{
	SPI1_WriteOneByte(0x03);	//read command	
	}
	i=SPIFlash_Addr >> 16;		
	SPI1_WriteOneByte(i);		//address(24)
	i=SPIFlash_Addr >> 8;		
	SPI1_WriteOneByte(i);		//address(16)
	i=SPIFlash_Addr;		
	SPI1_WriteOneByte(i);		//address(8)
		
	testvalue=0;
	ret=SPI1_TransmissionDMA(&testvalue, RXBuffer, (long)R_DataLength, 12);	//Mode=12,transmit address is constant and transmit address is byte mode, receive address is increase and recevie address is word mode. 
	if(ret != 0)
		while(1);				//SPI Timeout

	SPI1_CSHigh();	


	for(i=0; i< 0x1000; i++)
	{
		if(TXBuffer[i] != RXBuffer[i])
			while(1);
	}

//=========SPI Flash function PowerDown Verify =================================================				
	ret = SPIFlash_PowerDown();
	if(ret != 0)
		while(1)				//SPI Flash Timeout
		*P_WatchDog_Clear = C_WDT_Clear;

//=========SPI Flash function PowerDownRelease Verify =================================================					
	ret = SPIFlash_PowerDownRelease();
	if(ret != 0)
		while(1)				//SPI Flash Timeout
		*P_WatchDog_Clear = C_WDT_Clear;
}


//==================	SPI Flash Erase Test ==================================	
void F_SPIFlash_EraseTest(void)
{
	int ret;
	ret=SPIFlash_Erase(SPIFlash_Addr, C_64k_Erase);
	if(ret != 0)
		while(1);				//Erase Type Error, Erase Timeout, SPI Flash Busy
		
	do{
		ret=SPIFlash_RDSR();	//wait erase done
		if (ret==-1)
			while(1);
	  }while(ret & 0x01);	
}

//==============================================================================	
void F_BufferInitial(int value)
{	
	unsigned int i;
	for(i=0; i< 0x1000; i++)
	{
		TXBuffer[i] = value;
		value++;
		RXBuffer[i] = 0;
	}
}
