#ifndef	__SYSTEM_h__
#define	__SYSTEM_h__
//==================================================================================
// The information contained herein is the exclusive property of
// Generalplus Technology Co. And shall not be distributed, reproduced,
// or disclosed in whole in part without prior written permission.
//       (C) COPYRIGHT 2009   Generalplus TECHNOLOGY CO.                            
//                   ALL RIGHTS RESERVED
// The entire notice above must be reproduced on all authorized copies.
//==================================================================================
//==================================================================================
// Name                  : system.h
// Applied Body          : GPL951
// Programmer            : 
// Description           : system include header file
// History version       : 
// Rev #      Date         Who			Comments
// -----	 -----------   ---------	--------------------------------------------

//==================================================================================

//==========================================
// Constant define area
//==========================================


//==========================================
// Include file area
//==========================================


//==========================================
// External declare area
//==========================================
extern int R_128HzCounter;


//==========================================
// Public declare area
//==========================================


//==========================================
//Variable RAM declare area
//==========================================


//==========================================
// code starting 
//==========================================
//=======================================================================================
// Function name: F_SYS_Initial
// Purpose		: System Initial
// Parameter	: 
// Return		: 
// Destroy		: 
//=======================================================================================
extern void  F_SYS_Initial(void);


//****************************************************************
// Function    : F_Key_Scan_Initial
// Description : Key scan variable initialzation
// Destory     : R1
// Parameter   : None
// Return      : None
// Note        : None
//****************************************************************
extern void F_Key_Scan_Initial(void);


//****************************************************************
// Function    : F_SYS_ServiceLoop
// Description : Key scan and watchdog clear
// Destory     : R1, R2
// Parameter   : None
// Return      : None
// Note        : None
//****************************************************************
extern void F_SYS_ServiceLoop(void);	


//=======================================================================================
// Function name: F_SYS_GotoHaltMode
// Purpose		: Go to Halt Mode
// Parameter	: 
// Return		: 
// Destroy		: 
//=======================================================================================
extern void F_SYS_GotoHaltMode(void);


//=======================================================================================
// Function name: F_SYS_GotoDeepHaltMode
// Purpose		: Go to deep halt Mode
// Parameter	:
// Return		: 
// Destroy		: 
//=======================================================================================
extern void F_SYS_GotoDeepHaltMode(void);
	
	
//=======================================================================================
// Function name: F_SYS_CounterEnable
// Purpose		: Enable 128Hz INT
// Parameter	: 
// Return		: 
// Destroy		: r1
//=======================================================================================
extern void F_SYS_CounterEnable(void);
	
	
//=======================================================================================
// Function name: F_SYS_CounterDisable
// Purpose		: Disable 128Hz INT
// Parameter	: 
// Return		: None
// Destroy		: r1
//=======================================================================================
extern void F_SYS_CounterDisable(void);
		
	
//=======================================================================================
// Function name: F_SYS_GetCount
// Purpose		: Get 128Hz Counter
// Parameter	: None
// Return		: R1 (Counter Value)
// Destroy		: R1
//=======================================================================================
extern void F_SYS_GetCount(void);
	
#endif
